-- Imports the dkp values from dkpvalues.json to display them in the ingame tooltip.
-- Remember to name the file precisely and regularly update it!

function search_for_item(itemname)
    for index, value in next, dkp_value_table do
        if value["item"] == itemname then
            return value
        end
    end
end

function ranking_to_dkp(ranking)
    result = 0
    
    if ranking == "S" then
        result = 100
    elseif ranking == "A" then
        result = 50
    elseif ranking == "B" then
        result = 25
    elseif ranking == "C" then
        result = 10
    end
    
    return result
end

function get_class_icon(class)
    result = ""
    
    if class == "protwarr" then
        result = "|TINTERFACE\\ICONS\\ability_warrior_defensivestance:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "furywarr" then
        result = "|TINTERFACE\\ICONS\\ability_warrior_innerrage:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "hpal" then
        result = "|TINTERFACE\\ICONS\\inv_hammer_01.png:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "hunter" then
        result = "|TINTERFACE\\ICONS\\inv_weapon_bow_07.png:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "rogue" then
        result = "|TINTERFACE\\ICONS\\inv_throwingknife_04.png:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "rdruid" then
        result = "|TINTERFACE\\ICONS\\spell_nature_healingtouch:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "fdruiddps" then
        result = "|TINTERFACE\\ICONS\\ability_druid_catform:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "fdruidtank" then
        result = "|TINTERFACE\\ICONS\\ability_racial_bearform:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "mage" then
        result = "|TINTERFACE\\ICONS\\inv_staff_13.png:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "wl" then
        result = "|TINTERFACE\\ICONS\\spell_nature_drowsy.png:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "hpriest" then
        result = "|TINTERFACE\\ICONS\\inv_staff_30.png:12:12:0:0:64:64:4:60:4:60|t"
    elseif class == "spriest" then
        result = "|TINTERFACE\\ICONS\\spell_shadow_shadowwordpain:12:12:0:0:64:64:4:60:4:60|t"
    end
    
    return result
end

function format_tooltip(information)
    ranking = string.format("|c0099ccffRanking: %s - Value: %i DKP", information["final"], 
        ranking_to_dkp(information["final"]))
    
    s = false
    a = false
    b = false
    c = false
    
    s_classes = string.format("\n|c00E0E0E0%-3s", "S:")
    for key, value in next, information do
        if value == "S" and not(key == "final") then
            s_classes = s_classes .. get_class_icon(key)
            s = true
        end
    end
    if not s then 
        s_classes = nil
    end
    
    a_classes = string.format("\n|c00E0E0E0%-3s", "A:")
    for key, value in next, information do
        if value == "A" and not(key == "final") then
            a_classes = a_classes .. get_class_icon(key)
            a = true
        end
    end
    if not a then 
        a_classes = nil
    end
    
    b_classes = string.format("\n|c00E0E0E0%-3s", "B:")
    for key, value in next, information do
        if value == "B" and not(key == "final") then
            b_classes = b_classes .. get_class_icon(key)
            b = true
        end
    end
    if not b then 
        b_classes = nil
    end
    
    c_classes = string.format("\n|c00E0E0E0%-3s", "C:")
    for key, value in next, information do
        if value == "C" and not(key == "final") then
            c_classes = c_classes .. get_class_icon(key)
            c = true
        end
    end
    if not c then 
        c_classes = nil
    end
    
    return ranking, s_classes, a_classes, b_classes, c_classes
end

GameTooltip:HookScript("OnTooltipSetItem", function(tooltip, ...)
        local itemname, _ = tooltip:GetItem()

        information = search_for_item(itemname)
        
        if information then
            ranking, s, a, b, c = format_tooltip(information)
            
            if s then
                ranking = ranking .. s
            end
            if a then
                ranking = ranking .. a
            end
            if b then
                ranking = ranking .. b
            end
            if c then
                ranking = ranking .. c
            end
            
            tooltip:AddLine(ranking)
        end
    end)
